/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.team.repository.web.ui.internal.admin.DataTableContainer");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("net.jazz.ajax.core.internal.util");

dojo.declare("com.ibm.team.repository.web.ui.internal.admin.DataTableContainer", [dijit._Widget, dijit._Templated], {
		
	templateString: "<div class='com-ibm-team-repository-admin-table'><div class='wrapper'><div dojoAttachPoint='dataTableHeading'></div><table><tbody dojoAttachPoint='dataTableContainer'></tbody></table></div></div>",
	
	rowCount: 0,
	
	headers: "",
	
	addRow: function(data, columns){
		if(!columns) {
			columns = data.length;
		}
		var row = document.createElement("tr");
		if((this.rowCount%2) === 0){
			dojo.addClass(row, "alternate");
		}
		this.rowCount++;
		
		for (var i = 0; i < columns; i++) {
			var cell = document.createElement("td");
			var colData = data[i];
			if (colData) {
				// backwards compatibility with text prop - use content instead
				if(colData.text){
					colData.content = document.createTextNode(colData.text);
					delete colData.text;
				}				
				if(isNode(colData.content)) {
					var node = colData.content;
				} else {
					node = document.createTextNode(colData.content);
				}
				cell.appendChild(node);
				if (colData.style){
					dojo.addClass(cell, colData.style);
				}
			}
			row.appendChild(cell);
		}
		this.dataTableContainer.appendChild(row);
	},

	clearTable: function(){
		//	summary:
		//		Function to clear all the current rows in the table, except for the header.

		//Always leave the first row, which is the table header.
		while(this.dataTableContainer.firstChild.nextSibling){
			this.dataTableContainer.removeChild(this.dataTableContainer.firstChild.nextSibling);
		}
		this.rowCount = 0;
	},
	
	//
	// Widget lifecycle methods
	//

	postCreate: function(){
		if (this.heading) {
			var headingDiv = document.createElement("div");
			dojo.addClass(headingDiv, "heading");
			
			var labelSpan = document.createElement("span");
			labelSpan.innerHTML = this.heading.label;
			headingDiv.appendChild(labelSpan);
			
			if (this.heading.value) {
				var valueSpan = document.createElement("span");
				dojo.addClass(valueSpan, "headingValue");
				valueSpan.innerHTML = this.heading.value;
				headingDiv.appendChild(valueSpan);
			}
			this.dataTableHeading.appendChild(headingDiv);
		}
		if (this.headers) {
			var headerRow = document.createElement("tr");
			dojo.forEach(this.headers, function(header){
				var headerCell = document.createElement("th");
				var text = document.createTextNode(header);
				headerCell.appendChild(text);
				headerRow.appendChild(headerCell);
			});
			this.dataTableContainer.appendChild(headerRow);
		}
	}
});

function isNode(o){
	return o && o.nodeType && o.cloneNode;
}
})();